"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.transformY = transformY;
function transformY(y, hasYPercent) {
    var y0 = Math.abs(y[0].value);
    var y1 = Math.abs(y[1].value);

    // transform percent to px
    var value0 = hasYPercent ? y0 / 100 * boundingRect.height : y0;
    var value1 = hasYPercent ? y1 / 100 * boundingRect.height : y1;

    // add negative values to the top
    this.bounds.top = y[0].value <= 0 ? this.bounds.top + value0 : this.bounds.top;
    this.bounds.top = y[1].value <= 0 ? this.bounds.top + value1 : this.bounds.top;

    // add positive values to the bottom
    this.bounds.bottom = y[0].value >= 0 ? this.bounds.bottom + value0 : this.bounds.bottom;
    this.bounds.bottom = y[1].value >= 0 ? this.bounds.bottom + value1 : this.bounds.bottom;

    return this;
}

// export function transformBounds(
//     bounds = {
//         top: 0,
//         left: 0,
//         bottom: 0,
//         right: 0,
//     }
// ) {
//     this.bounds = bounds;

//     return {
//         transformY: (y, hasYPercent) => {
//             const y0 = Math.abs(y[0].value);
//             const y1 = Math.abs(y[1].value);

//             // transform percent to px
//             const value0 = hasYPercent ? y0 / 100 * boundingRect.height : y0;
//             const value1 = hasYPercent ? y1 / 100 * boundingRect.height : y1;

//             // add negative values to the top
//             this.bounds.top =
//                 y[0].value <= 0 ? this.bounds.top + value0 : this.bounds.top;
//             this.bounds.top =
//                 y[1].value <= 0 ? this.bounds.top + value1 : this.bounds.top;

//             // add positive values to the bottom
//             this.bounds.bottom =
//                 y[0].value >= 0
//                     ? this.bounds.bottom + value0
//                     : this.bounds.bottom;
//             this.bounds.bottom =
//                 y[1].value >= 0
//                     ? this.bounds.bottom + value1
//                     : this.bounds.bottom;

//             return this;
//         },

//         transformX: (x, hasXPercent) => {
//             const x0 = Math.abs(x[0].value);
//             const x1 = Math.abs(x[1].value);

//             // transform percent to px
//             const value0 = hasXPercent ? x0 / 100 * boundingRect.width : x0;
//             const value1 = hasXPercent ? x1 / 100 * boundingRect.width : x1;

//             // add negative values to the left
//             this.bounds.left = x[0].value <= 0 ? this.bounds.left + value0 : this.bounds.left;
//             this.bounds.left = x[1].value <= 0 ? this.bounds.left + value1 : this.bounds.left;

//             // add positive values to the right
//             this.bounds.right = x[0].value >= 0 ? this.bounds.right + value0 : this.bounds.right;
//             this.bounds.right = x[1].value >= 0 ? this.bounds.right + value1 : this.bounds.right;

//             return this;
//         },
//     };
//     };
// }